#<profile4xi profile = "31"/> 
#<program4xi program = "walk2gen4meta.py">   
#<abstract4xi abstract = "walks through spefied main folders generating partner4xi.json for all vps users "/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "set ack2debug, KB4Tailoring for test; run walk2parse4app.py for one; verify at https://html5.validator.nu/"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2gen4meta' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                                
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 

import walk2gen4dev


#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from multiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from walk2parse4app import walk2parse4app

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global ack2title

global domain2xi
global folder2xi
global portal2xi 

global count2skipped 
global count2total
global file2output

global index2app4yo

global index2head
global index2brand
global index2net4biz
global index2pod4biz
global index2copter4biz
global index2net4pat
global index2pod4pat
global index2copter4pat
global index2net4mil
global index2pod4mil
global index2copter4mil
global index2base4biz
global index2base4pat
global index2base4mil

global index2sensor4biz
global index2sensor4pat
global index2sensor4mil

global index2rd4biz
global index2rd4pat
global index2rd4mil

global index2prd4biz
global index2prd4pat
global index2prd4mil

global index2lambdamobi4biz
global index2lambdamobi4pat
global index2lambdamobi4mil

global index2alphamobi4biz
global index2alphamobi4pat
global index2alphamobi4mil

global index2sw4core
global index2scope4xi
global index2studio4xi

global index2waves4yo
global index2cat4yo
global index2ai4yo
global index2auto4yo
global index2space4yo
global index2ocean4yo 
global index2fish4yo
global index2hunt4yo
global index2quantum4yo
global index2science4yo
global index2special4yo
global index2unmanned4yo
global index2wearable4yo

global index2alpha4yo
global index2a4yo
global index2b4yo
global index2c4yo
global index2d4yo
global index2e4yo
global index2f4yo
global index2g4yo
global index2h4yo
global index2i4yo
global index2j4yo
global index2k4yo
global index2l4yo
global index2m4yo
global index2n4yo
global index2o4yo
global index2p4yo
global index2q4yo
global index2r4yo
global index2s4yo
global index2t4yo
global index2u4yo
global index2v4yo
global index2w4yo
global index2x4yo
global index2y4yo
global index2z4yo

global index2contact4yo
global index2cbo4yo
global index2cco4yo
global index2cdo4yo
global index2ceo4yo
global index2cfo4yo
global index2cmo4yo
global index2cpo4yo
global index2cto4yo
global index2sec4yo
global index2venture4yo
global index2legal4yo
global index2endhtml4yo

global kb2ai
global kb2app
global kb2dev
global kb2org
global kb2com

global kb2slogan
global slogan2xi
global kb2portal
global kb2type
global kb2un

global kb2partner

global kb2proxy
global kb2contact
global kb2time
global kb2user

global app2config
global port2config
global domain2config

global keys2ai
global keys2app
global keys2dev
global keys2org
global keys2com
global keys2slogan
global keys2portal
global keys2proxy
global keys2config
global keys2type
global key2time
global keys2user
global keys2partner

global key2ai                            
global key2app
global key2dev
global key2org
global key2com
global key2slogan
global key2portal
global key2proxy
global key2config
global key2type
global key2time
global key2user
global key2partner

global name2create
global path2write4xi

global PickleKB4Xi
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True   # True / False  
ack2title = False  # False: title in input file is not used to solve domain2xi
                   # True:  domain2xi is soolved using input folder id

count2skipped = 0
count2total   = 0                 
                    
domain2xi = "encrypted_dragonxi"                    
file2output = None

index2app4yo = 0

kb2ai      = {} 
kb2app     = {}  
kb2dev     = {}
kb2pass    = {}  
kb2org     = {}  
kb2com     = {}
kb2proxy   = {}
kb2contact = {}
kb2slogan  = {}
kb2portal  = {}
kb2type    = {}
kb2un      = {}
kb2time    = {}
kb2user    = {}

keys2ai      = kb2ai.keys()  
keys2app     = kb2app.keys()
keys2dev     = kb2dev.keys()
keys2org     = kb2org.keys()
keys2com     = kb2com.keys()
keys2slogan  = kb2slogan.keys()
keys2portal  = kb2portal.keys()
keys2proxy   = kb2proxy.keys()
key2contact  = kb2contact.keys()
keys2type    = kb2type.keys()
keys2un      = kb2un.keys()
keys2time    = kb2time.keys()
keys2user    = kb2user.keys()
keys2un      = kb2un.keys()


path2write4xi = None
path2write4xi = VersionKB4Xi['output2genjson4partner'] 

# common
import partner4xi
from partner4xi import kb2partner
from partner4xi import keys2partner

# common
import meta4xi
from meta4xi import kb2meta
from meta4xi import keys2meta

# individual active ones
import aceit2app4partner
import aeronautics2app4partner
import aeronautics2dev4partner
import antarcticocean2ai4partner
import antarcticocean2app4partner
import antarcticocean2dev4partner
import app2ace4yo2app4partner
import arcticocean2ai4partner
import arcticocean2app4partner
import arcticocean2dev4partner
import atlanticocean2app4partner
import atlanticocean2dev4partner
import autonomousdevice2ai4partner
import autonomousdevice2app4partner
import autonomousdevice2dev4partner
import autonomousrobot2app4partner
import autonomousrobot2dev4partner
import autonomoussystem2ai4partner
import autonomoussystem2app4partner
import autonomoussystem2dev4partner
import autonomousvehicle2app4partner
import autonomousvehicle2dev4partner
import beyondspace2app4partner
import caribbeansea2ai4partner
import caribbeansea2app4partner
import caribbeansea2dev4partner
import cryogenics2app4partner
import cryogenics2dev4partner
import deeplearninginference2app4partner

import dragonxi2ai4partner
import dragonxi2app4partner
import dragonxi2com4partner
import dragonxi2dev4partner

import indianocean2app4partner
import indianocean2dev4partner
import jetport2app4partner
import jetport2dev4partner
import lidarsystem2ai4partner
import lidarsystem2app4partner
import lidarsystem2dev4partner
import loihi2app4partner
import loihi2dev4partner
import longrangehunting2app4partner
import marlinfishing2ai4partner
import marlinfishing2app4partner
import marlinfishing2dev4partner
import namib2app4partner
import objectdetection2app4partner
import oceanography2app4partner
import opalstack2app4partner
import opalstack2dev4partner
import pacificocean2ai4partner
import pacificocean2app4partner
import pacificocean2dev4partner
import personalrobot2ai4partner
import personalrobot2app4partner
import personalrobot2dev4partner
import porthos2app4partner
import porthos2dev4partner
import reasonit2app4partner
import rubalkhali2app4partner
import senseit2app4partner
import southernocean2ai4partner
import southernocean2app4partner
import southernocean2dev4partner
import spacescience2app4partner
import transferlearning2app4partner
import unmannedsystem2app4partner
import unmannedsystem2dev4partner
import yocto2app4partner
import yodragonxi2com4partner
import yodragonxi2org4partner

# individual active ones
from aceit2app4partner import kb2partner4aceit_app
kb2partner['aceit_app'] = kb2partner4aceit_app

from aeronautics2app4partner import kb2partner4aeronautics_app
kb2partner['aeronautics_app'] = kb2partner4aeronautics_app
from aeronautics2dev4partner import kb2partner4aeronautics_dev
kb2partner['aeronautics_dev'] = kb2partner4aeronautics_dev

from antarcticocean2ai4partner import kb2partner4antarcticocean_ai
kb2partner['antarcticocean_ai'] = kb2partner4antarcticocean_ai
from antarcticocean2app4partner import kb2partner4antarcticocean_app
kb2partner['antarcticocean_app'] = kb2partner4antarcticocean_app
from antarcticocean2dev4partner import kb2partner4antarcticocean_dev
kb2partner['antarcticocean_dev'] = kb2partner4antarcticocean_dev

from antarcticocean2ai4partner import kb2partner4antarcticocean_ai
kb2partner['antarcticocean_ai'] = kb2partner4antarcticocean_ai
from antarcticocean2app4partner import kb2partner4antarcticocean_app
kb2partner['antarcticocean_app'] = kb2partner4antarcticocean_app
from antarcticocean2dev4partner import kb2partner4antarcticocean_dev
kb2partner['antarcticocean_dev'] = kb2partner4antarcticocean_dev

from atlanticocean2app4partner import kb2partner4atlanticocean_app
kb2partner['atlanticocean_app'] = kb2partner4atlanticocean_app
from atlanticocean2dev4partner import kb2partner4atlanticocean_dev
kb2partner['atlanticocean_dev'] = kb2partner4atlanticocean_dev

from autonomousdevice2ai4partner import kb2partner4autonomousdevice_ai
kb2partner['autonomousdevice_ai'] = kb2partner4autonomousdevice_ai
from autonomousdevice2app4partner import kb2partner4autonomousdevice_app
kb2partner['autonomousdevice_app'] = kb2partner4autonomousdevice_app
from autonomousdevice2dev4partner import kb2partner4autonomousdevice_dev
kb2partner['autonomousdevice_dev'] = kb2partner4autonomousdevice_dev

from autonomousrobot2app4partner import kb2partner4autonomousrobot_app
kb2partner['autonomousrobot_app'] = kb2partner4autonomousrobot_app
from autonomousrobot2dev4partner import kb2partner4autonomousrobot_dev
kb2partner['autonomousrobot_dev'] = kb2partner4autonomousrobot_dev

from autonomoussystem2ai4partner import kb2partner4autonomoussystem_ai
kb2partner['autonomoussystem_ai'] = kb2partner4autonomoussystem_ai
from autonomoussystem2app4partner import kb2partner4autonomoussystem_app
kb2partner['autonomoussystem_app'] = kb2partner4autonomoussystem_app
from autonomoussystem2dev4partner import kb2partner4autonomoussystem_dev
kb2partner['autonomoussystem_dev'] = kb2partner4autonomoussystem_dev

from autonomousvehicle2app4partner import kb2partner4autonomousvehicle_app
kb2partner['autonomousvehicle_app'] = kb2partner4autonomousvehicle_app
from autonomousvehicle2dev4partner import kb2partner4autonomousvehicle_dev
kb2partner['autonomousvehicle_dev'] = kb2partner4autonomousvehicle_dev

from beyondspace2app4partner import kb2partner4beyondspace_app
kb2partner['beyondspace_app'] = kb2partner4beyondspace_app

from caribbeansea2ai4partner import kb2partner4caribbeansea_ai
kb2partner['caribbeansea_ai'] = kb2partner4caribbeansea_ai
from caribbeansea2app4partner import kb2partner4caribbeansea_app
kb2partner['caribbeansea_app'] = kb2partner4caribbeansea_app
from caribbeansea2dev4partner import kb2partner4caribbeansea_dev
kb2partner['caribbeansea_dev'] = kb2partner4caribbeansea_dev


from cryogenics2app4partner import kb2partner4cryogenics_app
kb2partner['cryogenics_app'] = kb2partner4cryogenics_app
from cryogenics2dev4partner import kb2partner4cryogenics_dev
kb2partner['cryogenics_dev'] = kb2partner4cryogenics_dev

from deeplearninginference2app4partner import kb2partner4deeplearninginference_app
kb2partner['deeplearninginference_app'] = kb2partner4deeplearninginference_app

from dragonxi2ai4partner import kb2partner4dragonxi_ai
kb2partner['dragonxi_ai'] = kb2partner4dragonxi_ai
from dragonxi2app4partner import kb2partner4dragonxi_app
kb2partner['dragonxi_app'] = kb2partner4dragonxi_app
from dragonxi2com4partner import kb2partner4dragonxi_com
kb2partner['dragonxi_com'] = kb2partner4dragonxi_com
from dragonxi2dev4partner import kb2partner4dragonxi_dev
kb2partner['dragonxi_dev'] = kb2partner4dragonxi_dev

from indianocean2app4partner import kb2partner4indianocean_app
kb2partner['indianocean_app'] = kb2partner4indianocean_app
from indianocean2dev4partner import kb2partner4indianocean_dev
kb2partner['indianocean_dev'] = kb2partner4indianocean_dev

from jetport2app4partner import kb2partner4jetport_app
kb2partner['jetport_app'] = kb2partner4jetport_app
from jetport2dev4partner import kb2partner4jetport_dev
kb2partner['jetport_dev'] = kb2partner4jetport_dev

from lidarsystem2ai4partner import kb2partner4lidarsystem_ai
kb2partner['lidarsystem_ai'] = kb2partner4lidarsystem_ai
from lidarsystem2app4partner import kb2partner4lidarsystem_app
kb2partner['lidarsystem_app'] = kb2partner4lidarsystem_app
from lidarsystem2dev4partner import kb2partner4lidarsystem_dev
kb2partner['lidarsystem_dev'] = kb2partner4lidarsystem_dev

from loihi2app4partner import kb2partner4loihi_app
kb2partner['loihi_app'] = kb2partner4loihi_app
from loihi2dev4partner import kb2partner4loihi_dev
kb2partner['loihi_dev'] = kb2partner4loihi_dev

from longrangehunting2app4partner import kb2partner4longrangehunting_app
kb2partner['longrangehunting_app'] = kb2partner4longrangehunting_app

from marlinfishing2ai4partner import kb2partner4marlinfishing_ai
kb2partner['marlinfishing_ai'] = kb2partner4marlinfishing_ai
from marlinfishing2app4partner import kb2partner4marlinfishing_app
kb2partner['marlinfishing_app'] = kb2partner4marlinfishing_app
from marlinfishing2dev4partner import kb2partner4marlinfishing_dev
kb2partner['marlinfishing_dev'] = kb2partner4marlinfishing_dev

from namib2app4partner import kb2partner4namib_app
kb2partner['namib_app'] = kb2partner4namib_app

from objectdetection2app4partner import kb2partner4objectdetection_app
kb2partner['objectdetection_app'] = kb2partner4objectdetection_app

from oceanography2app4partner import kb2partner4oceanography_app
kb2partner['oceanography_app'] = kb2partner4oceanography_app

from opalstack2app4partner import kb2partner4opalstack_app
kb2partner['opalstack_app'] = kb2partner4opalstack_app
from opalstack2dev4partner import kb2partner4opalstack_dev
kb2partner['opalstack_dev'] = kb2partner4opalstack_dev

from pacificocean2ai4partner import kb2partner4pacificocean_ai
kb2partner['pacificocean_ai'] = kb2partner4pacificocean_ai
from pacificocean2app4partner import kb2partner4pacificocean_app
kb2partner['pacificocean_app'] = kb2partner4pacificocean_app
from pacificocean2dev4partner import kb2partner4pacificocean_dev
kb2partner['pacificocean_dev'] = kb2partner4pacificocean_dev

from personalrobot2ai4partner import kb2partner4personalrobot_ai
kb2partner['personalrobot_ai'] = kb2partner4personalrobot_ai
from personalrobot2app4partner import kb2partner4personalrobot_app
kb2partner['personalrobot_app'] = kb2partner4personalrobot_app
from personalrobot2dev4partner import kb2partner4personalrobot_dev
kb2partner['personalrobot_dev'] = kb2partner4personalrobot_dev

from porthos2app4partner import kb2partner4porthos_app
kb2partner['porthos_app'] = kb2partner4porthos_app
from porthos2dev4partner import kb2partner4porthos_dev
kb2partner['porthos_dev'] = kb2partner4porthos_dev

from reasonit2app4partner import kb2partner4reasonit_app
kb2partner['reasonit_app'] = kb2partner4reasonit_app

from rubalkhali2app4partner import kb2partner4rubalkhali_app
kb2partner['rubalkhali_app'] = kb2partner4rubalkhali_app

from senseit2app4partner import kb2partner4senseit_app
kb2partner['senseit_app'] = kb2partner4senseit_app

from southernocean2ai4partner import kb2partner4southernocean_ai
kb2partner['southernocean_ai'] = kb2partner4southernocean_ai
from southernocean2app4partner import kb2partner4southernocean_app
kb2partner['southernocean_app'] = kb2partner4southernocean_app
from southernocean2dev4partner import kb2partner4southernocean_dev
kb2partner['southernocean_dev'] = kb2partner4southernocean_dev

from spacescience2app4partner import kb2partner4spacescience_app
kb2partner['spacescience_app'] = kb2partner4spacescience_app

from transferlearning2app4partner import kb2partner4transferlearning_app
kb2partner['transferlearning_app'] = kb2partner4transferlearning_app

from unmannedsystem2app4partner import kb2partner4unmannedsystem_app
kb2partner['unmannedsystem_app'] = kb2partner4unmannedsystem_app
from unmannedsystem2dev4partner import kb2partner4unmannedsystem_dev
kb2partner['unmannedsystem_dev'] = kb2partner4unmannedsystem_dev

from yocto2app4partner import kb2partner4yocto_app
kb2partner['yocto_app'] = kb2partner4yocto_app

from yodragonxi2com4partner import kb2partner4yodragonxi_com
kb2partner['yodragonxi_com'] = kb2partner4yodragonxi_com

from yodragonxi2org4partner import kb2partner4yodragonxi_org
kb2partner['yodragonxi_org'] = kb2partner4yodragonxi_org

keys2partner = kb2partner.keys()

import aceit2app4meta
import aeronautics2app4meta
import aeronautics2dev4meta
import antarcticocean2ai4meta
import antarcticocean2app4meta
import antarcticocean2dev4meta
import app2ace4yo2app4meta
import arcticocean2app4meta
import arcticocean2dev4meta
import atlanticocean2app4meta
import atlanticocean2dev4meta
import autonomousdevice2ai4meta
import autonomousdevice2app4meta
import autonomousdevice2dev4meta
import autonomousrobot2app4meta
import autonomousrobot2dev4meta
import autonomoussystem2ai4meta
import autonomoussystem2app4meta
import autonomoussystem2dev4meta
import autonomousvehicle2app4meta
import autonomousvehicle2dev4meta
import beyondspace2app4meta
import caribbeansea2ai4meta
import caribbeansea2app4meta
import caribbeansea2dev4meta
import cryogenics2dev4meta
import deeplearninginference2app4meta

import dragonxi2ai4meta
import dragonxi2app4meta
import dragonxi2com4meta
import dragonxi2dev4meta

import indianocean2app4meta
import indianocean2dev4meta
import jetport2app4meta
import jetport2dev4meta
import lidarsystem2ai4meta
import lidarsystem2app4meta
import lidarsystem2dev4meta
import longrangehunting2app4meta
import marlinfishing2ai4meta
import marlinfishing2app4meta
import marlinfishing2dev4meta
import namib2app4meta
import objectdetection2app4meta
import oceanography2app4meta
import opalstack2app4meta
import opalstack2dev4meta
import pacificocean2ai4meta
import pacificocean2app4meta
import pacificocean2dev4meta
import personalrobot2ai4meta
import personalrobot2app4meta
import personalrobot2dev4meta
import porthos2app4meta
import porthos2dev4meta
import reasonit2app4meta
import rubalkhali2app4meta
import senseit2app4meta
import southernocean2ai4meta
import southernocean2app4meta
import spacescience2app4meta
import transferlearning2app4meta
import unmannedsystem2dev4meta
import yocto2app4meta
import yourdragonxi2com4meta
import yourdragonxi2org4meta

from aceit2app4meta import kb2hash4aceit_app
kb2meta['aceit_app'] = kb2hash4aceit_app

from aeronautics2app4meta import kb2hash4aeronautics_app
kb2meta['aeronautics_app'] = kb2hash4aeronautics_app
from aeronautics2dev4meta import kb2hash4aeronautics_dev
kb2meta['aeronautics_dev'] = kb2hash4aeronautics_dev

from antarcticocean2ai4meta import kb2hash4antarcticocean_ai
kb2meta['antarcticocean_ai'] = kb2hash4antarcticocean_ai
from antarcticocean2app4meta import kb2hash4antarcticocean_app
kb2meta['antarcticocean_app'] = kb2hash4antarcticocean_app
from antarcticocean2dev4meta import kb2hash4antarcticocean_dev
kb2meta['antarcticocean_dev'] = kb2hash4antarcticocean_dev

from app2ace4yo2app4meta import kb2hash4app2ace4yo_app
kb2meta['app2ace4yo_app'] = kb2hash4app2ace4yo_app

from arcticocean2ai4meta import kb2hash4arcticocean_ai
kb2meta['arcticocean_ai'] = kb2hash4arcticocean_ai
from arcticocean2app4meta import kb2hash4arcticocean_app
kb2meta['arcticocean_app'] = kb2hash4arcticocean_app
from arcticocean2dev4meta import kb2hash4arcticocean_dev 
kb2meta['arcticocean_dev'] = kb2hash4arcticocean_dev

from atlanticocean2app4meta import kb2hash4atlanticocean_app
kb2meta['atlanticocean_app'] = kb2hash4atlanticocean_app 
from atlanticocean2dev4meta import kb2hash4atlanticocean_dev
kb2meta['atlanticocean_dev'] = kb2hash4atlanticocean_dev

from autonomousdevice2ai4meta import kb2hash4autonomousdevice_ai
kb2meta['autonomousdevice_ai'] = kb2hash4autonomousdevice_ai 
from autonomousdevice2app4meta import kb2hash4autonomousdevice_app
kb2meta['autonomousdevice_app'] = kb2hash4autonomousdevice_app 
from autonomousdevice2dev4meta import kb2hash4autonomousdevice_dev 
kb2meta['autonomousdevice_dev'] = kb2hash4autonomousdevice_dev

from autonomousrobot2app4meta import kb2hash4autonomousrobot_app
kb2meta['autonomousrobot_app'] = kb2hash4autonomousrobot_app 
from autonomousrobot2dev4meta import kb2hash4autonomousrobot_dev
kb2meta['autonomousrobot_dev'] = kb2hash4autonomousrobot_dev

from autonomoussystem2ai4meta import kb2hash4autonomoussystem_ai
kb2meta['autonomoussystem_ai'] = kb2hash4autonomoussystem_ai
from autonomoussystem2app4meta import kb2hash4autonomoussystem_app
kb2meta['autonomoussystem_app'] = kb2hash4autonomoussystem_app
from autonomoussystem2dev4meta import kb2hash4autonomoussystem_dev
kb2meta['autonomoussystem_dev'] = kb2hash4autonomoussystem_dev 

from autonomousvehicle2app4meta import kb2hash4autonomousvehicle_app 
kb2meta['autonomousvehicle_app'] = kb2hash4autonomousvehicle_app
from autonomousvehicle2dev4meta import kb2hash4autonomousvehicle_dev 
kb2meta['autonomousvehicle_dev'] = kb2hash4autonomousvehicle_dev

from beyondspace2app4meta import kb2hash4beyondspace_app 
kb2meta['beyondspace_app'] = kb2hash4beyondspace_app

from caribbeansea2ai4meta import kb2hash4caribbeansea_ai
kb2meta['caribbeansea_ai'] = kb2hash4caribbeansea_ai
from caribbeansea2app4meta import kb2hash4caribbeansea_app
kb2meta['caribbeansea_app'] = kb2hash4caribbeansea_app
from caribbeansea2dev4meta import kb2hash4caribbeansea_dev
kb2meta['caribbeansea_dev'] = kb2hash4caribbeansea_dev 

from cryogenics2app4meta import kb2hash4cryogenics_app
kb2meta['cryogenics_app'] = kb2hash4cryogenics_app
from cryogenics2dev4meta import kb2hash4cryogenics_dev
kb2meta['cryogenics_dev'] = kb2hash4cryogenics_dev 

from deeplearninginference2app4meta import kb2hash4deeplearninginference_app 
kb2meta['deeplearninginference_app'] = kb2hash4deeplearninginference_app

from dragonxi2ai4meta import kb2hash4dragonxi_ai
kb2meta['dragonxi_ai'] = kb2hash4dragonxi_ai
from dragonxi2app4meta import kb2hash4dragonxi_app
kb2meta['dragonxi_app'] = kb2hash4dragonxi_app
from dragonxi2com4meta import kb2hash4dragonxi_com
kb2meta['dragonxi_com'] = kb2hash4dragonxi_com 
from dragonxi2dev4meta import kb2hash4dragonxi_dev 
kb2meta['dragonxi_dev'] = kb2hash4dragonxi_dev

from indianocean2app4meta import kb2hash4indianocean_app
kb2meta['indianocean_app'] = kb2hash4indianocean_app
from indianocean2dev4meta import kb2hash4indianocean_dev
kb2meta['indianocean_dev'] = kb2hash4indianocean_dev 

from jetport2app4meta import kb2hash4jetport_app
kb2meta['jetport_app'] = kb2hash4jetport_app
from jetport2dev4meta import kb2hash4jetport_dev
kb2meta['jetport_app'] = kb2hash4jetport_app

from lidarsystem2ai4meta import kb2hash4lidarsystem_ai
kb2meta['lidarsystem_ai'] = kb2hash4lidarsystem_ai 
from lidarsystem2app4meta import kb2hash4lidarsystem_app
kb2meta['lidarsystem_app'] = kb2hash4lidarsystem_app 
from lidarsystem2dev4meta import kb2hash4lidarsystem_dev
kb2meta['lidarsystem_dev'] = kb2hash4lidarsystem_dev 

from loihi2app4meta import kb2hash4loihi_app
kb2meta['loihi_app'] = kb2hash4loihi_app
from loihi2dev4meta import kb2hash4loihi_dev
kb2meta['loihi_dev'] = kb2hash4loihi_dev  

from longrangehunting2app4meta import kb2hash4longrangehunting_app 
kb2meta['longrangehunting_app'] = kb2hash4longrangehunting_app

from marlinfishing2ai4meta import kb2hash4marlinfishing_ai
kb2meta['marlinfishing_ai'] = kb2hash4marlinfishing_ai
from marlinfishing2app4meta import kb2hash4marlinfishing_app
kb2meta['marlinfishing_app'] = kb2hash4marlinfishing_app 
from marlinfishing2dev4meta import kb2hash4marlinfishing_dev 
kb2meta['marlinfishing_dev'] = kb2hash4marlinfishing_dev

from namib2app4meta import kb2hash4namib_app 
kb2meta['namib_app'] = kb2hash4namib_app

from objectdetection2app4meta import kb2hash4objectdetection_app
kb2meta['objectdetection_app'] = kb2hash4objectdetection_app 

from oceanography2app4meta import kb2hash4oceanography_app 
kb2meta['oceanography_app'] = kb2hash4oceanography_app

from opalstack2app4meta import kb2hash4opalstack_app
kb2meta['opalstack_app'] = kb2hash4opalstack_app 
from opalstack2dev4meta import kb2hash4opalstack_dev
kb2meta['opalstack_dev'] = kb2hash4opalstack_dev 

from pacificocean2ai4meta import kb2hash4pacificocean_ai
kb2meta['pacificocean_ai'] = kb2hash4pacificocean_ai 
from pacificocean2app4meta import kb2hash4pacificocean_app
kb2meta['pacificocean_app'] = kb2hash4pacificocean_app 
from pacificocean2dev4meta import kb2hash4pacificocean_dev 
kb2meta['pacificocean_dev'] = kb2hash4pacificocean_dev

from personalrobot2ai4meta import kb2hash4personalrobot_ai
kb2meta['personalrobot_ai'] = kb2hash4personalrobot_ai
from personalrobot2app4meta import kb2hash4personalrobot_app  
kb2meta['personalrobot_app'] = kb2hash4personalrobot_app
from personalrobot2dev4meta import kb2hash4personalrobot_dev 
kb2meta['personalrobot_dev'] = kb2hash4personalrobot_dev

from porthos2app4meta import kb2hash4porthos_app 
kb2meta['porthos_app'] = kb2hash4porthos_app
from porthos2dev4meta import kb2hash4porthos_dev 
kb2meta['porthos_dev'] = kb2hash4porthos_dev

from reasonit2app4meta import kb2hash4reasonit_app 
kb2meta['reasonit_app'] = kb2hash4reasonit_app

from rubalkhali2app4meta import kb2hash4rubalkhali_app 
kb2meta['rubalkhali_app'] = kb2hash4rubalkhali_app

from senseit2app4meta import kb2hash4senseit_app 
kb2meta['senseit_app'] = kb2hash4senseit_app

from southernocean2ai4meta import kb2hash4southernocean_ai
kb2meta['southernocean_ai'] = kb2hash4southernocean_ai 
from southernocean2app4meta import kb2hash4southernocean_app
kb2meta['southernocean_app'] = kb2hash4southernocean_app
from southernocean2dev4meta import kb2hash4southernocean_dev 
kb2meta['southernocean_dev'] = kb2hash4southernocean_dev

from spacescience2app4meta import kb2hash4spacescience_app 
kb2meta['spacescience_app'] = kb2hash4spacescience_app

from transferlearning2app4meta import kb2hash4transferlearning_app 
kb2meta['transferlearning_app'] = kb2hash4transferlearning_app

from unmannedsystem2dev4meta import kb2hash4unmannedsystem_dev 
kb2meta['unmannedsystem_dev'] = kb2hash4unmannedsystem_dev
from unmannedsystem2app4meta import kb2hash4unmannedsystem_app 
kb2meta['unmannedsystem_app'] = kb2hash4unmannedsystem_app

from yocto2app4meta import kb2hash4yocto_app
kb2meta['yocto_app'] = kb2hash4yocto_app

from yourdragonxi2com4meta import kb2hash4yodragonxi_com
kb2meta['yodragonxi_com'] = kb2hash4yodragonxi_com 
from yourdragonxi2org4meta import kb2hash4yodragonxi_org
kb2meta['yodragonxi_org'] = kb2hash4yodragonxi_org 

#from meta4xi import keys2meta
keys2meta = kb2meta.keys()




# -------------------------------------------------------------------------------------------------
# KB2TIME - times for users to triger cronjob
# -------------------------------------------------------------------------------------------------
kb2time = {}

kb2tick4aero = {}
kb2tick4aero [0] = '00 '
kb2tick4aero [1] = '1 '
kb2tick4aero [2] = '* '
kb2tick4aero [3] = '* '
kb2tick4aero [4] = '* '
kb2time['aero'] = kb2tick4aero

kb2tick4antarcticocean = {}
kb2tick4antarcticocean [0] = '30 '
kb2tick4antarcticocean [1] = '1 '
kb2tick4antarcticocean [2] = '* '
kb2tick4antarcticocean [3] = '* '
kb2tick4antarcticocean [4] = '* '
kb2time['antarcticocean'] = kb2tick4antarcticocean

kb2tick4appadmin = {}
kb2tick4appadmin [0] = '00 '
kb2tick4appadmin [1] = '2 '
kb2tick4appadmin [2] = '* '
kb2tick4appadmin [3] = '* '
kb2tick4appadmin [4] = '* '
kb2time['appadmin'] = kb2tick4appadmin 

kb2tick4arcticocean = {}
kb2tick4arcticocean [0] = '30 '
kb2tick4arcticocean [1] = '2 '
kb2tick4arcticocean [2] = '* '
kb2tick4arcticocean [3] = '* '
kb2tick4arcticocean [4] = '* '
kb2time['arcticocean'] = kb2tick4arcticocean

kb2tick4atlanticocean = {}
kb2tick4atlanticocean [0] = '00 '
kb2tick4atlanticocean [1] = '3 '
kb2tick4atlanticocean [2] = '* '
kb2tick4atlanticocean [3] = '* '
kb2tick4atlanticocean [4] = '* '
kb2time['atlanticocean'] = kb2tick4atlanticocean

kb2tick4autonomous = {}
kb2tick4autonomous [0] = '30 '
kb2tick4autonomous [1] = '3 '
kb2tick4autonomous [2] = '* '
kb2tick4autonomous [3] = '* '
kb2tick4autonomous [4] = '* '
kb2time['autonomous'] = kb2tick4autonomous

kb2tick4business = {}
kb2tick4business [0] = '00 '
kb2tick4business [1] = '4 '
kb2tick4business [2] = '* '
kb2tick4business [3] = '* '
kb2tick4business [4] = '* '
kb2time['business'] = kb2tick4business

kb2tick4devadmin = {}
kb2tick4devadmin [0] = '30 '
kb2tick4devadmin [1] = '4 '
kb2tick4devadmin [2] = '* '
kb2tick4devadmin [3] = '* '
kb2tick4devadmin [4] = '* '
kb2time['devadmin'] = kb2tick4devadmin

kb2tick4dragon = {}
kb2tick4dragon [0] = '00 '
kb2tick4dragon [1] = '5 '
kb2tick4dragon [2] = '* '
kb2tick4dragon [3] = '* '
kb2tick4dragon [4] = '* '
kb2time['dragon'] = kb2tick4dragon


kb2tick4indianocean = {}
kb2tick4indianocean [0] = '30 '
kb2tick4indianocean [1] = '5 '
kb2tick4indianocean [2] = '* '
kb2tick4indianocean [3] = '* '
kb2tick4indianocean [4] = '* '
kb2time['indianocean'] = kb2tick4indianocean

kb2tick4intelligence = {}
kb2tick4intelligence [0] = '00 '
kb2tick4intelligence [1] = '6 '
kb2tick4intelligence [2] = '* '
kb2tick4intelligence [3] = '* '
kb2tick4intelligence [4] = '* '
kb2time['intelligence'] = kb2tick4intelligence


kb2tick4pacificocean = {}
kb2tick4pacificocean [0] = '30 '
kb2tick4pacificocean [1] = '6 '
kb2tick4pacificocean [2] = '* '
kb2tick4pacificocean [3] = '* '
kb2tick4pacificocean [4] = '* '
kb2time['pacificocean'] = kb2tick4pacificocean

kb2tick4relax = {}
kb2tick4relax [0] = '00 '
kb2tick4relax [1] = '7 '
kb2tick4relax [2] = '* '
kb2tick4relax [3] = '* '
kb2tick4relax [4] = '* '
kb2time['relax'] = kb2tick4relax

kb2tick4science  = {} 
kb2tick4science [0] = '30 '
kb2tick4science [1] = '7 '
kb2tick4science [2] = '* '
kb2tick4science [3] = '* '
kb2tick4science [4] = '* '
kb2time['science'] = kb2tick4science


kb2tick4southernocean = {}
kb2tick4southernocean [0] = '00 '
kb2tick4southernocean [1] = '8 '
kb2tick4southernocean [2] = '* '
kb2tick4southernocean [3] = '* '
kb2tick4southernocean [4] = '* '
kb2time['southernocean'] = kb2tick4southernocean

kb2tick4theater = {}
kb2tick4theater [0] = '30 '
kb2tick4theater [1] = '8 '
kb2tick4theater [2] = '* '
kb2tick4theater [3] = '* '
kb2tick4theater [4] = '* '
kb2time['theater'] = kb2tick4theater

keys2time = kb2time.keys()



# -------------------------------------------------------------------------------------------------
# KB2SLOGAN - you may keep it as it is, even if you cancel applications JATKA
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2slogan
keys2slogan  = kb2slogan.keys()

#  
# -------------------------------------------------------------------------------------------------
# KB2PORTAL - the module developed from walk2gen4fpm.py - long names differ to those of fpm J
# yoy may keep it at it is even a domain is cancelled
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2portal
keys2portal = kb2portal.keys()


# -------------------------------------------------------------------------------------------------
# KB2UN
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2un
keys2un = kb2un.keys()



# -------------------------------------------------------------------------------------------------
# KB2PROXY 
# https://my.opalstack.com/applications/ <-- search 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2proxy
keys2proxy = kb2proxy.keys()



# -------------------------------------------------------------------------------------------------
# KB2USER 
# https://my.opalstack.com/users/  
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2user
keys2user = kb2user.keys()


# -------------------------------------------------------------------------------------------------
# KB2TYPE
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import kb2type 
keys2type = kb2type.keys()  


# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2write = '.html'                      # object types to be written
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
        # COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'walk2gen4meta': 'NACK4TRACE' # turns off, no comment on 
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # walk2gen4meta

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        # COMPLETED  TAILORING:  10:11:46 04/02/20 FLE Daylight Time

#</function4xi>             

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "zero2index4app" usage = "zeroes indexes
#">                      
# ----------------------------------------------------------------------------------------------------------    
from walk2gen4dev import zero2index4app
#</function4xi>

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2head4app" usage = "
#   sets header app 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2head4app
#</function4xi>  
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2brand4app" usage = "
#   sets brand to app 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2brand4app
#</function4xi

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2dragon4app" usage = "
#   sets dragon to app 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2dragon4app
#</function4xi

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2net4biz" usage = "
#   sets kb for set2net4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2net4biz
#</function4xi  
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2pod4biz" usage = "
#   sets kb2pod4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2pod4biz
#</function4xi 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2copter4biz" usage = "
#   sets kb to copter4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2copter4biz
#</function4xi
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2net4pat" usage = "
#   sets kb to net4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2net4pat
#</function4xi   

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2pod4pat" usage = "
#   sets kb to 2pod4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2pod4pat
#</function4xi    
 

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2copter4pat" usage = "
#   sets kb to copterpat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2copter4pat
#</function4xi      

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2net4mil" usage = "
#   sets kb to net4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2net4mil
#</function4xi 

           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2pod4mil" usage = "
#   sets kb to pod4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2pod4mil
#</function4xi 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2copter4mil" usage = "
#   sets kb to copter4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2copter4mil

#</function4xi 

          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2base4biz" usage = "
#   sets kb to base4biz
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2base4biz
#</function4xi 
          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2base4pat" usage = "
#   sets kb to base4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2base4pat
#</function4xi 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2base4mil" usage = "
#   sets kb to base4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2base4mil
#</function4xi 
          
          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sensor4biz" usage = "
#   sets kb to sensor4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2sensor4biz
#</function4xi     
    
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sensor4pat" usage = "
#   sets kb to sensor4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2sensor4pat
#</function4xi  

              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sensor4mil" usage = "
#   sets kb to sensor4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2sensor4mil
#</function4xi 


              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2rd4biz" usage = "
#   sets kb to rd4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2rd4biz
#</function4xi               

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2rd4pat" usage = "
#   sets kb to rd4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2rd4pat
#</function4xi     
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2rd4mil" usage = "
#   sets kb to rd4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2rd4mil
#</function4xi  

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2prd4biz" usage = "
#   sets kb to prdbiz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2prd4biz
#</function4xi

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2prd4pat" usage = "
#   sets kb to prd4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2prd4pat
#</function4xi    

           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2prd4mil" usage = "
#   sets kb to prd4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2prd4mil
#</function4xi  

           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2lambdamobi4biz" usage = "
#   sets kb to lambdamobi4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2lambdamobi4biz
#</function4xi  
           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2lambdamobi4pat" usage = "
#   sets kb to lambdamobi4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2lambdamobi4pat
#</function4xi  

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2lambdamobi4mil" usage = "
#   sets kb to lambdamobi4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2lambdamobi4mil
#</function4xi  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2alphamobi4biz" usage = "
#   sets kb to alphamobi4biz 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2alphamobi4biz
#</function4xi  
           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2alphamobi4pat" usage = "
#   sets kb to alphamobi4pat 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2alphamobi4pat
#</function4xi  

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2alphamobi4mil" usage = "
#   sets kb to alphamobi4mil 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2alphamobi4mil
#</function4xi  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sw4core" usage = "
#   sets kb to sw4core 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2sw4core
#</function4xi 

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2scope4xi" usage = "
#   sets kb to scope4xi 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2scope4xi
#</function4xi     

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2studio4xi" usage = "
#   sets kb to studio4xi 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2studio4xi
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2waves4yo" usage = "
#   sets kb to waves4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2waves4yo
#</function4xi

               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cat4yo" usage = "
#   sets kb to cat4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cat4yo
#</function4xi
   
   
               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2ai4yo" usage = "
#   sets kb to ai4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2ai4yo
#</function4xi


            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2auto4yo" usage = "
#   sets kb to auto4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2auto4yo


#</function4xi    


            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2space4yo" usage = "
#   sets kb to space4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2space4yo

#</function4xi      


           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2ocean4yo" usage = "
#   sets kb to ocean4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2ocean4yo


#</function4xi    

           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2fish4yo" usage = "
#   sets kb to fish4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2fish4yo
#</function4xi 


           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2hunt4yo" usage = "
#   sets kb to hunt4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2hunt4yo
#</function4xi 


           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2quantum4yo" usage = "
#   sets kb to quantum4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2quantum4yo
#</function4xi 
 
          
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2science4yo" usage = "
#   sets kb to science4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2science4yo
#</function4xi 
         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2special4yo" usage = "
#   sets kb to special4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2special4yo
#</function4xi


         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2unmanned4yo" usage = "
#   sets kb to unmanned4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2unmanned4yo
#</function4xi


         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2wearable4yo" usage = "
#   sets kb to wearable4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2wearable4yo
#</function4xi
         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2alpha4yo" usage = "
#   sets kb to alpha4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2alpha4yo
#</function4xi

         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2a4yo" usage = "
#   sets kb to a4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2a4yo
#</function4xi


         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2b4yo" usage = "
#   sets kb to 2b4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2b4yo
#</function4xi
         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2c4yo" usage = "
#   sets kb to 2c4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2c4yo
#</function4xi

         
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2d4yo" usage = "
#   sets kb to d4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2d4yo
#</function4xi
 
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2e4yo" usage = "
#   sets kb to 2e4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2e4yo
#</function4xi
 
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2f4yo" usage = "
#   sets kb to f4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2f4yo
#</function4xi
 
      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2g4yo" usage = "
#   sets kb to 2g4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2g4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2h4yo" usage = "
#   sets kb to h4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2h4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2i4yo" usage = "
#   sets kb to i4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2i4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2j4yo" usage = "
#   sets kb to j4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2j4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2k4yo" usage = "
#   sets kb to k4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2k4yo
 #</function4xi
      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2l4yo" usage = "
#   sets kb to l4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2l4yo
#</function4xi
      
      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2m4yo" usage = "
#   sets kb to 2m4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2m4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2n4yo" usage = "
#   sets kb to n4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2n4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2o4yo" usage = "
#   sets kb to o4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2o4yo
#</function4xi

      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2p4yo" usage = "
#   sets kb to p4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2p4yo
#</function4xi
 
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2q4yo" usage = "
#   sets kb to q4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2q4yo
#</function4xi


     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2r4yo" usage = "
#   sets kb to r4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2r4yo
#</function4xi
 
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2s4yo" usage = "
#   sets kb to s4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2s4yo
#</function4xi

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2t4yo" usage = "
#   sets kb to 2t4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2t4yo
#</function4xi
 
   
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2u4yo" usage = "
#   sets kb to u4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2u4yo
#</function4xi
 
  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2v4yo" usage = "
#   sets kb to v4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2v4yo
#</function4xi
 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2w4yo" usage = "
#   sets kb to w4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2w4yo
#</function4xi

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2x4yo" usage = "
#   sets kb to x4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2x4yo
#</function4xi

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2y4yo" usage = "
#   sets kb to y4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2y4yo
#</function4xi

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2z4yo" usage = "
#   sets kb to z4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2z4yo
#</function4xi
 
 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2contact4yo" usage = "
#   sets kb to contact4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2contact4yo
#</function4xi
 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cbo4yo" usage = "
#   sets kb to cbo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cbo4yo
#</function4xi
 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cco4yo" usage = "
#   sets kb to cco4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cco4yo
#</function4xi

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cdo4yo" usage = "
#   sets kb to cdo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cdo4yo
#</function4xi
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2ceo4yo" usage = "
#   sets kb to ceo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2ceo4yo
#</function4xi

        

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cfo4yo" usage = "
#   sets kb to cfo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cfo4yo
#</function4xi

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cmo4yo" usage = "
#   sets kb to cmo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cmo4yo
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cpo4yo" usage = "
#   sets kb to cpo4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cpo4yo
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2cto4yo" usage = "
#   sets kb to cto4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2cto4yo
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sec4yo" usage = "
#   sets kb to sec4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2sec4yo
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2venture4yo" usage = "
#   sets kb to venture4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2venture4yo
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2legal4yo" usage = "
#   sets kb to legal4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2legal4yo
#</function4xi

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2power4yo" usage = "
#   sets kb to power4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2power4yo 
#</function4xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2endhtml4yo" usage = "
#   sets kb to endhtml4yo 
#"> 
# -------------------------------------------------------------------------------------------------
from walk2gen4dev import set2endhtml4yo
#</function4xi





    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2gen4meta"
    method2print = "walk2gen4meta" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2gen4meta.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2gen4meta.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2gen4meta sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2gen4meta.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2gen4meta.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2gen4meta.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4meta.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2gen4meta.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2gen4meta.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2gen4meta" usage = "
#   generates partner4xi.php
#"> 
# -------------------------------------------------------------------------------------------------
def walk2gen4meta(target2explore):
    global ack2title
    global appdir2xi
    global app2xi
    
    global count2skipped
    global count2total
    
    global domain2xi
    global slogan2xi
    global folder2xi
    global portal2xi
    global ack2debug
    
    global kb2app
    global kb2dev
    global kb2org
    global kb2com
    global kb2contact
    global kb2proxy
    global kb2portal
    global kb2slogan
    global kb2type
    global kb2time
    global kb2user
      
                              
    global keys2app
    global keys2dev
    global keys2org
    global keys2com
    global keys2contact  
    global keys2slogan  
    global keys2type
    global keys2time
    global keys2user
                          
    global key2app
    global key2dev
    global key2org
    global key2com 
    global key2slogan
    global key2type
    global key2time
    global key2user  
     
    global name2create
    global path2write4xi                           # path for output source targets
    global port2xi
    global profile2write                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2gen4meta"
    method2print = "walk2gen4meta" 
 
    message2print = "{(Step 0A1/33) using" + "; t2xi-using-by-walk2gen4meta: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    # 
    message2print = "{(Step 0A2/33) got" + "; target2explore-got-by-walk2gen4meta: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean//antarcticocean_ai//hashtag4xi.php; time: 13:25:15 02/06/24 FLE Standard Time}
    

    # ---------------------------------------------------------------------------------------------
    # (Step 4/33) OF WALK2GEN4META - OPEN OUTPUT FILE
    # ---------------------------------------------------------------------------------------------   
    path2output = target2explore
    
    message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2gen4meta to: " + str(path2output) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean//antarcticocean_ai//hashtag4xi.php; time: 13:25:15 02/06/24 FLE Standard Time}

    try:    
        file2output = open(path2output,'w') 
        message2print = "{(Step 4B/33) opened" + "; file2output-opened-by-walk2gen4meta: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # <_io.TextIOWrapper name='H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean//antarcticocean_ai//hashtag4xi.php' mode='w' encoding='cp1252'>; time: 13:25:15 02/06/24 FLE Standard Time}
    

        # -----------------------------------------------------------------------------------------
        # Retrieve hashtag4xi.json and generate hashtag4xi.php
        # -----------------------------------------------------------------------------------------           
        kb2meta = {}    
        kb2meta[0] = '<?php' + '\n' 
    
        kb2meta[1] = '// json meta file' + '\n'
        kb2meta[2] = '$file2meta = "hashtag4xi.json";' + '\n'
    
        kb2meta[3] = '// retrieve meta contents' + '\n'
        kb2meta[4] = '$data2meta = file_get_contents($file2meta);' + '\n'
        kb2meta[5] = "" + '\n'
        kb2meta[6] = '// decode it to php object' + '\n'
        kb2meta[7] = '$obj2meta = json_decode($data2meta);' + '\n'
        kb2meta[8] = "" + '\n'
        
        doctype2meta = "<!doctype html>"
        kb2meta[9] = 'echo ' + '"' + doctype2meta + '"' + ';' + '\n'
        # echo "<!doctype html>";
        
        html2meta = "<html>"
        kb2meta[10] = 'echo ' + '"' + html2meta + '"'  + ';' + '\n'
        # echo "<html>";
        
        head2meta = "<head>"
        kb2meta[11] = 'echo ' + '"' + head2meta  + '"'  + ';' + '\n'
        # echo "<head>"; 
        
        link2meta  = '<link rel='
        short2meta  = "'shortcut icon'"
        href2meta= ' href='
        url2meta = "'../../dragonxi.ico'"
        rest2meta = '>'
        kb2meta[12] = 'echo ' + '"' + link2meta + short2meta + href2meta + url2meta + rest2meta + '"' + ';' + '\n'
        # echo "<link rel='shortcut icon' href='../../dragonxi.ico'>";
        
        charset2meta = "<meta charset='UTF-8'>"
        kb2meta[13] = 'echo ' + '"' + charset2meta + '"' + ';' + '\n'
        # echo "<meta charset='UTF-8'>";
        
        title2meta = "<title>" + domain2xi + " | meta " + "</title>"
        
        kb2meta[14] = 'echo ' + '"' + title2meta + '"' + ';' + '\n'
        # echo "<title>$domain2fiber | AI | UAS | LH2 | Artificial Intelligence | Autonomous | Unmanned |  Hydrogen |</title>";
        
        body2meta       = "<body>"
        kb2meta[16] = 'echo ' + '"' + body2meta + '"' + ';' + '\n'
        # echo "<body>";
                       
       
        kb2meta[17] = '// echo meta data hashtags' + '\n'
        
        # max defined for each 
        kb2meta[18] = '$key2meta = 0;' + '\n'
        kb2meta[19] = '$max2key = $obj2meta->{$key2meta};' + '\n'
            
        kb2meta[20] = 'for ($key2meta = 1; $key2meta <= $max2key; $key2meta++) {' + '\n'
        kb2meta[21] = '    try {' + '\n'
        kb2meta[22] = '	    echo "<h4>";' + '\n'
        kb2meta[23] = '        echo $obj2meta->{$key2meta};' + '\n'
        kb2meta[24] = '        echo "</h4>";' + '\n'
        kb2meta[25] = '        }' + '\n'
        kb2meta[26] = '    catch (exception $e) {' + '\n'
        kb2meta[27] = '        echo "<h4>";' + '\n'
        kb2meta[28] = '	       echo "** failed to echo json object **";' + '\n'
        kb2meta[29] = '	       echo "</h4>";' + '\n'
        kb2meta[30] = '    }' + '\n'
        kb2meta[31] = '    finally {' + '\n'
        kb2meta[32] = '	    echo "<br />";' + '\n'
        kb2meta[33] = '             }' + '\n'
        kb2meta[34] = '    }' + '\n'
        
        kb2meta[35] = 'echo "</body>";' + '\n'
        kb2meta[36] = 'echo "</html>";' + '\n'
        kb2meta[37] = '?>' + '\n'
        
        
        keys2meta = kb2meta.keys()
        for key2meta in keys2meta:
            line2write = kb2meta[key2meta]    
            file2output.write(line2write)
                 
        # -----------------------------------------------------------------------------------------
        # (Step 5/33) OF WALK2GEN4META - CLOSE OUTPUT
        # -----------------------------------------------------------------------------------------            
        file2output.close()
        message2print = "{(Step 5A/33) closed" + "; file2output-closed-by-walk2gen4meta: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <_io.TextIOWrapper name='H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean//antarcticocean_ai//hashtag4xi.php' mode='w' encoding='cp1252'>; time: 13:25:15 02/06/24 FLE Standard Time}

        
        # ==================================================================
        # hashtag4xi.php <-- generated file by this program for each domain
        # ==================================================================
        # <?php
        # // json meta file
        # $file2meta = "hashtag4xi.json";
        # // retrieve meta contents
        # $data2meta = file_get_contents($file2meta);
        # 
        # // decode it to php object
        # $obj2meta = json_decode($data2meta);
        # 
        # // set style
        # echo '<body  style="background-color:#D6D8DC">';
        # 
        # // echo meta data hashtags
        # $max2key = 8;
        # for ($key2meta = 0; $key2meta <= $max2key; $key2meta++) {
        #     try {
        # 	    echo "<h4>";
        #         echo $obj2meta->{$key2meta};
        #         echo "</h4>";
        #         }
        #     catch (exception $e) {
        #         echo "<h4>";
        # 	       echo "** failed to echo json object **";
        # 	       echo "</h4>";
        #     }
        #     finally {
        #         echo "</br>";
        #         }
        #     }
        # echo "</body>";
        # ?>
    except:
        # for example other than _ai folders for .ai domains
        pass   
             
    
#</function4xi>
    


    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     


# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global appdir2xi
    global app2xi
    
    global count2skipped
    global count2total
   
    global domain2xi
    global slogan2xi
    
    global folder2xi
    
    global portal2xi
    global port2xi
    
    global kb2app
    global kb2portal
    global kb2proxy
    global kb2proxy
    global kb2type
    global kb2user
    
    global keys2type
    global keys2user
    
    global key2user
    global path2write4xi
    global profile2write

    global t2xi
    global trace_object_count   
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2GEN4META - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi  at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0   

    set2trace4replace()                                                                                             # trace all classes and functions in the system
    deny2trace4replace()                                                                                            # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2GEN4META - VERSION 2.11 STARTED ", time4xi())
    # VERSION 2.11 STARTED  13:25:15 02/06/24 FLE Standard Time
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2GEN4META - PIPE2FETCH ", pipe2fetch)    
        # (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002531860>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002531908>)
    
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2GEN4META - QUEUE2FETCH ", queue2fetch)    
        # <queue4xi.Queue4Xi object at 0x0000000002531400>
        
        print("(Step 1D/33) OF MAIN WALK2GEN4META - PATH2WRITE4XI ", path2write4xi)
        # H://temp//job2studio4xi//out//all2aijson4partner///
    
    for dir2walk in DirectoryWalker(path2write4xi):
        # ----------------------------------------------------------------------------------------- 
        # aero ... theater
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(dir2walk):
            print("(Step 2A/33) OF MAIN WALK2GEN4META - VPS USER DIRECTORY: ", dir2walk)
            # H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean
            # 
            
            # -----------------------------------------------------------------------------------------
            # (Step 2B/33) OF WALK2REPLACE4APP - VPS USER FOLDER 
            # -----------------------------------------------------------------------------------------
            string2skip = '/'
            folder2xi = dir2walk
            max2try = 33
            count2try = 0
            while 1:
                index2skip = str.find(folder2xi,string2skip)
                count2try = count2try + 1
                if (index2skip == -1) or (count2try > max2try):
                    break
                else:
                    folder2xi = folder2xi[index2skip+1:]
          
            print("(Step 2C/33) OF MAIN WALK2GEN4META - VPS USER: ", folder2xi)
            # antarcticocean         
            
            key2user = folder2xi
            
            if key2user in keys2user:
                # 'aero' ... 'theater'
                kb2gen = kb2user[key2user]
                # [0] = 'fpm2aero', [1] = 'fpm2jetport_app', kb2fpm4aero [2] = 'fpm2jetport_dev', [3] = 'fpm2ultrafan_app', [4] = 'fpm2ultrafan_dev'
                
                keys2gen = kb2gen.keys()
                for key2gen in keys2gen:
                    if key2gen == 0:
                        # vps user i.e. not app
                        pass
                    else:
                        # -----------------------------------------------------------------------------------------
                        # HASHTAG4XI.PHP FOR EACH _APP _DEV JATKAA
                        # -----------------------------------------------------------------------------------------

                        app2xi = kb2gen[key2gen]
                        print("(Step 2F/33) OF MAIN WALK2GEN4META - APP2XI: ", app2xi) 
                        # fpm2antarcticocean_ai 
       
                        if app2xi in keys2proxy:
                            if app2xi in keys2portal: 
                                domain2xi = kb2portal[app2xi]
                                print("(Step 2G/33) OF MAIN WALK2GEN4META - DOMAIN2XI: ", domain2xi)
                                # antarcticocean.ai
                            
                                port2xi = kb2proxy[app2xi] 
                                print("(Step 2H/33) OF MAIN WALK2GEN4META - PORT2XI: ", port2xi)
                                # 99999 
                        
                                appdir2xi = app2xi[4:]
                                print("(Step 2I/33) OF MAIN WALK2GEN4META - APPDIR2XI: ", appdir2xi)
                                # antarcticocean_ai
                                
                                
                                file2target = dir2walk + '//' + appdir2xi + '//' +  'hashtag4xi' + '.php'
                                print("(Step 2J/33) OF MAIN WALK2GEN4META - FILE2TARGET: ", file2target)
                                # H://temp//job2studio4xi//out//all2aijson4partner//antarcticocean//antarcticocean_ai//hashtag4xi.php
                               
                        
                                
                                walk2gen4meta(file2target)
                            else:
                                print("(Step 2Z1/33) OF MAIN WALK2GEN4META - ** ERROR APP2XI ", appdir2xi)
                                #  
                                print("(Step 2Z2/33) OF MAIN WALK2GEN4META - ** ERROR APP2XI NOT IN KB2GEN KEYS ", keys2gen)
                                # 
                                     
                        else:
                           print("(Step 2Z3/33) OF MAIN WALK2GEN4META - ** ERROR APP2XI ", app2xi)
                           # 
                           print("(Step 2Z4/33) OF MAIN WALK2GEN4META - ** ERROR APP2XI NOT KEYS2PROXY ", keys2proxy)
                    pass
                pass      
            else:
                break
                # print("(Step 2Z5/33) OF MAIN WALK2GEN4META - ** ERROR: KEY2USER: ", key2user)    
                # 
                # print("(Step 2Z6/33) OF MAIN WALK2GEN4META - ** ERROR KEY2USER NOT KEYS2USER: ", keys2user)
                
                
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 33A/33) OF MAIN WALK2GEN4META - VERSION 4.4 - OUT: ", path2write4xi," - PROFILE: ", profile2write, " COMPLETED  ", time4xi())
    # 
    # 
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2GEN4META - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2GEN4META - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()         
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "

# web sites:


# example of local hashtag4xi.php
# G:\temp\job2studio4xi\out\all2gen4meta\business\app2ace4yo_app\hashtag4xi.php
# ==================================================================
# hashtag4xi.php <-- generated file by this program for each domain
# ==================================================================
# <?php
# // json meta file
# $file2meta = "hashtag4xi.json";
# // retrieve meta contents
# $data2meta = file_get_contents($file2meta);
# 
# // decode it to php object
# $obj2meta = json_decode($data2meta);
# 
# echo "<!doctype html>";
# echo "<head>";
# echo "<link rel='shortcut icon' href='../../dragonxi.ico'>";
# // set style
# echo '<body  style="background-color:#D6D8DC">';
# echo "<title>aeronautics.app | meta </title>";
# echo "<body>";
# 
# // echo meta data hashtags
# $max2key = 9;
# for ($key2meta = 0; $key2meta <= $max2key; $key2meta++) {
#     try {
# 	    echo "<h4>";
#         echo $obj2meta->{$key2meta};
#         echo "</h4>";
#         }
#     catch (exception $e) {
#         echo "<h4>";
# 	       echo "** failed to echo json object **";
# 	       echo "</h4>";
# 	       break;
#     }
#     finally {
#         echo "</br>";
#         }
#     }
# echo "</body>";
# echo "</html>";
# ?>
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2gen4meta.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


